<script lang="ts">
  import { onDestroy } from 'svelte';

  /**
   * The target element where the container will be attached. If not provided, it defaults to the
   * document body.
   *
   * @type {HTMLElement | null | undefined}
   */
  export let target: HTMLElement | null | undefined = globalThis.document?.body;

  /**
   * A boolean flag that determines whether the container is visible or hidden.
   *
   * @type {boolean}
   */
  export let active: boolean = false;

  /**
   * Reference to the container element.
   *
   * @type {HTMLElement}
   */
  let ref: HTMLElement;

  // Whenever the 'active' or 'ref' variable changes, this reactive statement will trigger to show/hide the container.
  $: {
    if (ref) {
      active ? show() : hide();
    }
  }

  /** Show the container and attach it to the target element (default: document body). */
  const show = () => {
    target?.appendChild(ref);
    updateZIndex();
  };

  /** Hide the container by removing it from the DOM. */
  const hide = () => {
    ref?.parentNode?.removeChild(ref);
  };

  /** Update the z-index of the container to be on top within the target */
  const updateZIndex = () => {
    if (ref) {
      // Get the highest z-index value across the entire document
      const allElements = Array.from(target!.querySelectorAll('*'));
      let highestZIndex = 0;
      for (const element of allElements) {
        const zIndex = parseInt(getComputedStyle(element).zIndex) || 0;
        if (zIndex > highestZIndex) {
          highestZIndex = zIndex;
        }
      }

      ref.style.zIndex = (highestZIndex + 1).toString();
    }
  };

  /**
   * Cleanup function that will be called when the component is destroyed. It ensures that the
   * container is hidden when the component is removed from the DOM.
   */
  onDestroy(() => {
    setTimeout(() => {
      hide();
    });
  });
</script>

<!-- The container element whose reference is stored in 'ref' variable using 'bind:this'. -->
<div
  bind:this={ref}
  class="portal">
  <slot />
</div>

<style>
  .portal {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
  }
</style>
